/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include <assert.h>

#include "../include/jsonp.h"
#include "../include/bits/string.h"

#ifndef LIBCJSONP_SRC_INCLUDE_H
#define LIBCJSONP_SRC_INCLUDE_H

typedef struct {
    char* indent;
    size_t nmemb;
} indent_t;

typedef struct {
    union {
        vtype_bool       b;
        vtype_int8      s8;
        vtype_int16    s16;
        vtype_int32    s32;
        vtype_int64    s64;
        vtype_uint8     u8;
        vtype_uint16   u16;
        vtype_uint32   u32;
        vtype_uint64   u64;
        vtype_ldouble ldbl;
        vtype_map      map;
        vtype_list    list;
        vtype_string   str;
        vtype_pointer  ptr;
    } value[1];

    vtype type;
} value_t;

extern indent_t LIBCJSONP_BUILTIN_WITHOUT_INDENT[1];

extern const char* libcjsonp_builtin_fetch_number(value_t* x, const char *s, bool is_float);


#endif /* LIBCJSONP_SRC_INCLUDE_H */
